package service;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Andrendp
 */
public class DatabaseConnection {

    private Connection dbConn;
    private Statement statement = null;
    private ResultSet resultSet = null;

    /**
     * Connect to the database
     * @return boolean value
     */
    public boolean connect() {
        boolean isConnected = false;
        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            dbConn = DriverManager.getConnection("jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=" +
                    "C:/Database/Library.mdb");
            statement = dbConn.createStatement();
            isConnected = true;
        } catch (SQLException ex) {
            this.errorReport("Connect#" + ex.getMessage());
        } catch (ClassNotFoundException ex) {
            this.errorReport("Connect#" + ex.getMessage());
        }
        return isConnected;
    }

    /**
     * Disconnect from database
     * @return
     */
    public boolean disconnect() {
        try {
            this.dbConn.close();
            return true;
        } catch (SQLException ex) {
            this.errorReport("Disconnect#" + ex.getMessage());
        }
        return false;
    }

    /**
     *
     * @param username
     * @param password
     * @return
     */
    public boolean login(String username, String password) {
        try {
            String query = "SELECT * FROM Users WHERE username = '" + username +
                    "' AND password ='" + password + "'";
            resultSet = statement.executeQuery(query);
            if (resultSet.next()) {
                return true;
            }
        } catch (SQLException ex) {
            this.errorReport("Login#" + ex.getMessage());
        }
        return false;
    }

    /**
     * 
     * @param error
     */
    public void errorReport(String error) {
        System.out.println("#Method - " + error);
    }

    /**
     *
     * @return
     */
    public List<service.Book> getBooks() {
        List results = new ArrayList();
        try {
            String query = "SELECT bookID, bookTitle, bookDescription, bookQuantity FROM Books";
            resultSet = statement.executeQuery(query);
            while (resultSet.next()) {
                results.add(new Book(resultSet.getInt("bookID"),
                        resultSet.getString("bookTitle"),
                        resultSet.getString("bookDescription"),
                        resultSet.getInt("bookQuantity")));
            }
        } catch (SQLException ex) {
            this.errorReport("getBooks#" + ex.getMessage());
        }
        return results;
    }
}
